package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.WXMessageMapper;
import com.sa.ibiz.demo.demo.domain.WXMessage;
import com.sa.ibiz.demo.demo.service.WXMessageService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.WXMessageSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.WXAccountService;
import com.sa.ibiz.demo.demo.service.WXEntAppService;

/**
 * 实体[WXMessage] 服务对象接口实现
 */
@Service
public class WXMessageServiceImpl extends ServiceImplBase<WXMessageMapper, WXMessage> implements WXMessageService{

    @Autowired
    private WXAccountService wxaccountService;
    @Autowired
    private WXEntAppService wxentappService;

    @Resource
    private WXMessageMapper wxmessageMapper;


    @Override
    public boolean create(WXMessage et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(WXMessage et){
        this.beforeUpdate(et);
		this.wxmessageMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(WXMessage et){
		return et.getWxmessageid();  
    }

    @Override
    public boolean getDraft(WXMessage et)  {
    if((!StringUtils.isEmpty(et.getWxaccountid())) && et.getWxaccount() == null){
            try {
                et.setWxaccount(wxaccountService.getById(et.getWxaccountid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getWxentappid())) && et.getWxentapp() == null){
            try {
                et.setWxentapp(wxentappService.getById(et.getWxentappid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<WXMessage> listDefault(WXMessageSearchFilter filter) {
		return wxmessageMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<WXMessage> searchDefault(WXMessageSearchFilter filter) {
		return wxmessageMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return wxmessageMapper.selectRow(sql);
    }

 }